
;
; INCLUDES
;

include windows.inc
include kernel32.inc
include user32.inc
include Comctl32.inc
include shell32.inc
include ddraw.inc
include dinput8.inc
include comdlg32.inc

;
; LIBRARY INCLUDES
;
includelib kernel32.lib
includelib user32.lib
includelib Comctl32.lib
includelib comdlg32.lib
includelib shell32.lib
includelib ddraw.lib
includelib dinput8.lib
includelib dxguid.lib

WndProc		    PROTO :HWND, :UINT, :WPARAM, :LPARAM
WinMain         PROTO :DWORD,:DWORD,:DWORD,  :DWORD
AboutDlgProc    PROTO :HWND, :UINT, :WPARAM, :LPARAM
CpuSpeedDlgProc PROTO :HWND, :UINT, :WPARAM, :LPARAM

;
; MACROS
;

$invoke MACRO Fun:REQ, A:VARARG
    IFB <A>
      invoke Fun
    else
      invoke Fun, A
    endif
    
    exitm <eax> ; Return Value in eax
ENDM

MAKELONG MACRO A,B
    X = A OR (B SHL 16)
    mov eax,X
endm

;
;DEFINES
;

INIT_HEIGHT  = 216
INIT_WIDTH   = 250

;MENU DEFINES
ID_LOAD      =  9001
ID_STUFF_GO  =  9002
ID_EXIT      =  9003
ID_PAUSE     =  9004
ID_RESET     =  9005
ID_SIZE_X1   =  9006
ID_SIZE_X2   =  9007
ID_SIZE_X3   =  9008
ID_SIZE_X4   =  9009
ID_SOUND_ON  =  9010
ID_SOUND_OFF =  9011
ID_ABOUT     =  9012
ID_CPU_SPEED =  9013
ID_DEBUG     =  9014

.const
;RESOURCE
IDD_ABOUT      = 2000
IDD_DEBUGGER   = 2002
IDD_CPU_SPEED  = 2003
IDC_STC1       = 1001
IDC_STC2       = 1002
IDC_STC3       = 1003
IDC_IMG1       = 1004
IDC_CPU_SPEED  = 1005
IDC_EXIT_SPEED = 1006
IDC_SPEED_SIZE = 1007
IDI_CHIP8      = 500

.data
g_hWndClass db "CH8WindowClass",0
Error_msg   db "Window Registration Failed!",0
Error_msg2  db "Window Creation Failed!",0
Error       db "Error!",0
CRAZYCHIP8  db "Crazy Chip-8 v0.2 (32Bit ASM)",0
LOADROM     db "L&oad Rom...",0
RESETCPU    db "R&eset Cpu",0
EMULATION   db "E&mulation",0
PAUSE       db "P&ause Emulation",0
EXIT        db "E&xit",0
VIDEO       db "V&ideo",0
X1          db "x1",0
X2          db "x2",0
X3          db "x3",0
X4          db "x4",0
SOUND       db "S&ound",0
SOUND_ON    db "On",0
SOUND_OFF   db "Off",0
OPTIONS     db "O&ptions",0
DEBUGGER    db "De&bugger",0
CPU_SPEED   db "S&et CPU Speed",0
TOOLS       db "T&ools",0
ABOUT       db "A&bout",0
HELP        db "H&elp",0
DecFormat   db "%d",0
Fastest     db "Fastest",0
Slowest     db "Slowest",0
Hertz       db "%dHz",0

.data?

CommandLine     LPSTR     ?
hInstance       HINSTANCE ?
Main_hWnd       dd        ?
gHeight         dd        ?    
gWidth          dd        ?
FileSize        dd        ?
g_MainhWnd      HWND      ?
g_Running       BOOL      ?
EmulatorRunning BOOL      ?
SoundOn         BOOL      ?
PauseCpu        BOOL      ?

;#########################################################################